Subject: Re: [PATCH v2 iproute2-next] ip link: add sub-command to view and change DSA master

From: Stephen Hemminger <[email-masked]>
Date: Thu, 22 Sep 2022 12:04:49 -0700

On Thu, 22 Sep 2022 18:43:52 +0000
Vladimir Oltean <[email-masked]> wrote:

> On Thu, Sep 22, 2022 at 05:42:57PM +0200, Andrew Lunn wrote:
> > On Thu, Sep 22, 2022 at 02:41:24PM +0000, Vladimir Oltean wrote:  
> > > On Wed, Sep 21, 2022 at 03:33:49PM -0700, Stephen Hemminger wrote:  
> > > > There is no reason that words with long emotional history need to be used
> > > > in network command.
> > > >
> > > > https://inclusivenaming.org/word-lists/
> > > >
> > > > https://inclusivenaming.org/word-lists/tier-1/
> > > >
> > > > I understand that you and others that live in different geographies may
> > > > have different feelings about this. But the goal as a community to
> > > > not use names and terms that may hinder new diverse people from
> > > > being involved.  
> > > 
> > > The Linux kernel community is centered around a technical goal rather
> > > than political or emotional ones, and for this reason I don't think it's
> > > appropriate to go here in many more details than this.
> > > 
> > > All I will say is that I have more things to do than time to do them,
> > > and I'm not willing to voluntarily go even one step back about this and
> > > change the UAPI names while the in-kernel data structures and the
> > > documentation remain with the old names, because it's not going to stop
> > > there, and I will never have time for this.  
> > 
> > Yes, what is being asked for is a very thin veneer. Everything
> > underneath still uses master, and that is very unlikely to change. Do
> > we really gain anything with:
> > 
> > .BI master " DEVICE"
> > - change the DSA master (host network interface) responsible for handling the
> > local traffic termination of the given DSA switch user port. The selected
> > interface must be eligible for operating as a DSA master of the switch tree
> > which the DSA user port is a part of. Eligible DSA masters are those interfaces
> > which have an "ethernet" reference towards their firmware node in the firmware
> > description of the platform, or LAG (bond, team) interfaces which contain only
> > such interfaces as their ports.  
> 
> Let me make sure I understand you correctly.
> 
> You're saying that you think it should be enough if we make iproute2
> respond to "ip link set dev swp0 type dsa conduit eth0", and show "conduit"
> in the "ip link show dev swp0" output, both human-readable and json?
> And the man page description stays the same as what you've pasted, except
> for replacing:
> 
> .BI master " DEVICE"
> 
> with
> 
> .BI conduit " DEVICE"
> 
> and so does the IFLA_DSA_MASTER netlink attribute name stay the same?
> 
> In this message, David Ahern said that the 'master' keyword could be
> acceptable, if an alternative was also provided.
> https://patchwork.kernel.org/project/netdevbpf/patch/[email-masked]/#25002982
> So could we also keep 'master' in addition to 'conduit'? The kernel
> documentation already uses this iproute2 keyword:
> https://git.kernel.org/pub/scm/linux/kernel/git/netdev/net-next.git/tree/Documentation/networking/dsa/configuration.rst#n412

My preference would be that a non-offensive term was used and put
as the preferred choice in the man page. The other terms like master
will be accepted as synonyms.